﻿using UnityEngine;
using System.Collections;
using System.Collections.Generic;
using System;


namespace AT
{
	namespace UBF
	{
		namespace Behaviors
		{
			/// <summary>
			/// This behavior sends a state message serializing the state of the world as it sees it during each timestep
			/// </summary>
			public class DecentAgent_SendStateMessage : AT.UBF.Behavior
			{
				/// <summary>
				/// Does not create an actual action, just uses the behavior format to send state messages to all teamates
				/// </summary>
				/// <param name="state">State of the environment as visible to the tank</param>
				/// <returns>A null action</returns>
				protected override AT.UBF.Action genActionInternal(AT.UBF.State state)
				{
					//Generate and send the Message
					DecentAgentUtil.GenerateMessage(state, voteSourceID, "");

					//Return an action that doesn't vote on anything
					return new Action();
				}
			}
		}
	}
}