using UnityEngine;
using System;
using System.Collections;
using System.Collections.Generic;

namespace AT{
    namespace UBF{
        namespace Behaviors{

            /** Example Behavior that uses the Messages/Communication system.
             */
            public class GoodAgent_HandleMessage : AT.UBF.Behavior {
				public float priorityTarget = 0.8f;
				public float priorityCollision = 1.0f;
				
				
                protected override AT.UBF.Action genActionInternal(AT.UBF.State state){
                    AT.UBF.Action action = new AT.UBF.Action();
					int i = 0;
					
					while (state.messages.Length != i) {
						string messages = state.messages [i].getMessage();
						string sender = state.messages [i].getSender ();
						char[] splitChar = { '_' };


						string[] msgRcvd = messages.Split (splitChar);

						if (sender == state.self.getColor ()) {
							i++;
							continue;
						}
						//if message is Target Location && no enemies are in sight
						if (msgRcvd [0] == "T" && state.visibleEnemyTanks.Count < 1) {
							float x = Convert.ToSingle (msgRcvd [1]);
							float y = Convert.ToSingle (msgRcvd [2]);
							Vector2 targetPos = new Vector2 (x, y);
							
							action.SetTurnTracksRight (
								Util.findShortestTrackRotationToTarget (state.self.getPosition (), targetPos, state.self.getTracksRotation ()), 
								voteSourceID);
							action.SetPriority (priorityTarget, voteSourceID);
						
							
						} 
						//if message is Teammate Location
						else if (msgRcvd [0] == "M") {
							float x = Convert.ToSingle (msgRcvd [1]);
							float y = Convert.ToSingle (msgRcvd [2]);					
							Vector2 myPos = state.self.getPosition ();
							float dx = Math.Abs (myPos.x - x);
							float dy = Math.Abs (myPos.y - y);
							//if they are too close turn and move away
							if (dx < 5 && dy < 5) {
								action.SetTurnTracksRight (0.5f,voteSourceID);
								action.SetPriority (priorityCollision, voteSourceID);
							}
						}

						i++;	
					}
						

				
					/*
					if(state.visibleEnemyTanks.Count >= 1){
                        Vector2 targetPos = state.visibleEnemyTanks[0].getPosition(); 
						string targetMsg = "T_"+targetPos.x+"_"+targetPos.y;
						
						
						// This is a very simple example of using the message system to pass a message to our team
						// The following are the arguments required:
						// int sourceID, string sender, AT.Message.ReceiverType receiverType, string receiver,  string message
						string sender = state.self.getColor();
						string myTeam = state.self.getTeam().ToString(); // enum to string representation
						AT.Message msg = new AT.Message(voteSourceID, sender, AT.Message.ReceiverType.Team, myTeam, "Hello Team!");
						AT.Tank.SendMessage(msg);
                    }
					
					*/
					
                    return action;
                }
				
				public override void _ToDict(Dictionary<string, object> dict, bool saveLastAction){
					dict["PriorityTarget"] = priorityTarget;
                }
                
                
                public override void _FromDict(Dictionary<string, object> dict){
                    string bName = this.GetType().Name;
					priorityTarget = Util.FloatFromJsonDict("PriorityTarget", priorityTarget, bName, dict);

                }
            }
        }
    }
}